module Network.Salvia.Advanced.ExtendedFileSystem (hExtendedFileSystem) where

import Network.Salvia.Advanced.CleverCSS (hFilterCSS, hCleverCSS)
import Network.Salvia.Advanced.HsColour (hHighlightHaskell, hHsColour)
import Network.Salvia.Handlers.Directory (hDirectoryResource)
import Network.Salvia.Handlers.File (hFileResource)
import Network.Salvia.Handlers.FileSystem (hFileTypeDispatcher)
import Network.Salvia.Handlers.Rewrite (hWithDir)
import Network.Salvia.Httpd (Handler)

hExtendedFileSystem :: FilePath -> Handler ()
hExtendedFileSystem dir =
    hFileTypeDispatcher dir
    hDirectoryResource
  $ \r -> hHighlightHaskell (hHsColour r)
  $ hWithDir dir
  $ hFilterCSS hCleverCSS
  $ hFileResource r


